Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 2236)
@@ -17,9 +17,8 @@
    LOGICAL , PUBLIC ::   ln_dynldf_hor   = .TRUE.      !: horizontal (geopotential) direction
    LOGICAL , PUBLIC ::   ln_dynldf_iso   = .FALSE.     !: iso-neutral direction
-   REAL(wp), PUBLIC ::   rn_ahm_0        = 40000._wp   !: lateral laplacian eddy viscosity (m2/s)
+   REAL(wp), PUBLIC ::   rn_ahm_0_lap    = 40000._wp   !: lateral laplacian eddy viscosity (m2/s)
    REAL(wp), PUBLIC ::   rn_ahmb_0       =     0._wp   !: lateral laplacian background eddy viscosity (m2/s)
    REAL(wp), PUBLIC ::   rn_ahm_0_blp    =     0._wp   !: lateral bilaplacian eddy viscosity (m4/s)
-
-   REAL(wp), PUBLIC ::   ahm0, ahmb0, ahm0_blp       ! OLD namelist names
+   REAL(wp), PUBLIC ::   ahm0, ahmb0, ahm0_blp         ! OLD namelist names
 
 #if defined key_dynldf_c3d
@@ -36,5 +35,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!======================================================================
 END MODULE ldfdyn_oce
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 2236)
@@ -24,4 +24,5 @@
    USE phycst          ! physical constants
    USE zdfmxl          ! mixed layer depth
+   USE eosbn2
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
@@ -33,8 +34,14 @@
    PUBLIC   ldf_slp         ! routine called by step.F90
    PUBLIC   ldf_slp_init    ! routine called by opa.F90
+   PUBLIC ldf_slp_grif   !              "
 
    LOGICAL , PUBLIC, PARAMETER              ::   lk_ldfslp = .TRUE.   !: slopes flag
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   uslp, wslpi          !: i_slope at U- and W-points
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   vslp, wslpj          !: j-slope at V- and W-points
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   wslp2                !: wslp**2 from Griffies quarter cells
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   alpha, beta          !: alpha,beta at T points
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   tfw,sfw,ftu,fsu,ftv,fsv,ftud,fsud,ftvd,fsvd
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   psix_eiv
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   psiy_eiv
    
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   omlmask           ! mask of the surface mixed layer at T-pt
@@ -44,9 +51,11 @@
    !! * Substitutions
 #  include "domzgr_substitute.h90"
+#  include "ldftra_substitute.h90"
+#  include "ldfeiv_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -304,5 +313,4 @@
       END DO
          
-
       ! III.  Specific grid points     
       ! =========================== 
@@ -339,4 +347,468 @@
       !
    END SUBROUTINE ldf_slp
+
+   SUBROUTINE ldf_slp_grif ( kt )
+     !!----------------------------------------------------------------------
+     !!                 ***  ROUTINE ldf_slp_grif  ***
+     !!
+     !! ** Purpose :   Compute the squared slopes of neutral surfaces (slope
+     !!      of iso-pycnal surfaces referenced locally) ('key_traldfiso')
+     !!      at W-points using the Griffies quarter-cells.  Also calculates
+     !!      alpha and beta at T-points for use in the Griffies isopycnal
+     !!      scheme.
+     !!
+     !! ** Method  :   The slope in the i-direction is computed at U- and
+     !!      W-points (uslp, wslpi) and the slope in the j-direction is
+     !!      computed at V- and W-points (vslp, wslpj).
+     !!
+     !! ** Action : - alpha, beta
+     !!               wslp2 squared slope of neutral surfaces at w-points.
+     !!
+     !! History :
+     !!   9.0  !  06-10  (C. Harris)  New subroutine
+     !!----------------------------------------------------------------------
+     !! * Modules used
+     USE oce            , zdit  => ua,  &  ! use ua as workspace
+          zdis  => va,  &  ! use va as workspace
+          zdjt  => ta,  &  ! use ta as workspace
+          zdjs  => sa      ! use sa as workspace
+     !! * Arguments
+     INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
+
+     !! * Local declarations
+     INTEGER  ::   ji, jj, jk, ip, jp, kp  ! dummy loop indices
+     INTEGER  ::   iku, ikv                ! temporary integer
+     REAL(wp) ::   &
+          zt, zs, zh, zt2, zsp5, zp1t1,   &  ! temporary scalars
+          zdenr, zrhotmp, zdndt, zdddt,   &  !     "        "
+          zdnds, zddds, znum, zden,       &  !     "        "
+          zslope, za_sxe, zslopec, zdsloper,&  !     "        "
+          zfact, zepsln, zatempw,zatempu,zatempv, &   !     "        "
+          ze1ur,ze2vr,ze3wr,zdxt,zdxs,zdyt,zdys,zdzt,zdzs,zvolf,&
+          zr_slpmax,zdxrho,zdyrho,zabs_dzrho
+     REAL(wp), DIMENSION(jpi,jpj,jpk,0:1,0:1) ::   &
+          zsx,zsy
+     REAL(wp), DIMENSION(jpi,jpj,0:1,0:1) ::   &
+          zsx_ml_base,zsy_ml_base
+     REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
+          zdkt,zdks
+     REAL(wp), DIMENSION(jpi,jpj) ::   &
+          zr_ml_basew
+     !!----------------------------------------------------------------------
+
+     ! 0. Local constant initialization
+     ! --------------------------------
+     zr_slpmax = 1.0_wp/slpmax
+
+     ! zslopec=0.004
+     ! zdsloper=1000.0
+     zepsln=1e-25
+
+     SELECT CASE ( nn_eos )
+
+     CASE ( 0 )               ! Jackett and McDougall (1994) formulation
+
+        !                                                ! ===============
+        DO jk = 1, jpk                                   ! Horizontal slab
+           !                                             ! ===============
+           DO jj = 1, jpjm1
+              DO ji = 1, fs_jpim1
+                 zt = tb(ji,jj,jk)          ! potential temperature
+                 zs = sb(ji,jj,jk) - 35.0   ! salinity anomaly (s-35)
+                 zh = fsdept(ji,jj,jk)      ! depth in meters
+
+                 beta(ji,jj,jk) = ( ( -0.415613e-09 * zt + 0.555579e-07 ) * zt      &
+                      &                            - 0.301985e-05 ) * zt      &
+                      &   + 0.785567e-03                                      &
+                      &   + (     0.515032e-08 * zs                           &
+                      &         + 0.788212e-08 * zt - 0.356603e-06 ) * zs     &
+                      &   +(  (   0.121551e-17 * zh                           &
+                      &         - 0.602281e-15 * zs                           &
+                      &         - 0.175379e-14 * zt + 0.176621e-12 ) * zh     &
+                      &                             + 0.408195e-10   * zs     &
+                      &     + ( - 0.213127e-11 * zt + 0.192867e-09 ) * zt     &
+                      &                             - 0.121555e-07 ) * zh
+
+                 alpha(ji,jj,jk) = - beta(ji,jj,jk) *                       &
+                      &     (((( - 0.255019e-07 * zt + 0.298357e-05 ) * zt   &
+                      &                               - 0.203814e-03 ) * zt   &
+                      &                               + 0.170907e-01 ) * zt   &
+                      &   + 0.665157e-01                                      &
+                      &   +     ( - 0.678662e-05 * zs                         &
+                      &           - 0.846960e-04 * zt + 0.378110e-02 ) * zs   &
+                      &   +   ( ( - 0.302285e-13 * zh                         &
+                      &           - 0.251520e-11 * zs                         &
+                      &           + 0.512857e-12 * zt * zt           ) * zh   &
+                      &           - 0.164759e-06 * zs                         &
+                      &        +(   0.791325e-08 * zt - 0.933746e-06 ) * zt   &
+                      &                               + 0.380374e-04 ) * zh)
+
+              ENDDO
+           ENDDO
+        ENDDO
+
+     CASE ( 1 )
+
+        alpha(:,:,:)=-rn_alpha
+        beta(:,:,:)=0.0
+
+     CASE ( 2 )
+
+        alpha(:,:,:)=-rn_alpha
+        beta (:,:,:)=rn_beta
+
+     CASE ( 3 )
+
+        DO jk =1, jpk
+           DO jj = 1, jpjm1
+              DO ji = 1, fs_jpim1
+                 zt = tb(ji,jj,jk)
+                 zs = sb(ji,jj,jk)
+                 zh = fsdept(ji,jj,jk)
+                 zt2 = zt**2
+                 zsp5 = sqrt(ABS(zs))
+                 zp1t1=zh*zt
+                 znum=9.99843699e+02+zt*(7.35212840e+00+zt*(-5.45928211e-02+3.98476704e-04*zt)) &
+                      +zs*(2.96938239e+00-7.23268813e-03*zt+2.12382341e-03*zs)  &
+                      +zh*(1.04004591e-02+1.03970529e-07*zt2+5.18761880e-06*zs+ &
+                      zh*(-3.24041825e-08-1.23869360e-11*zt2))
+                 zden=1.00000000e+00+zt*(7.28606739e-03+zt*(-4.60835542e-05+zt*(3.68390573e-07+zt*1.80809186e-10))) &
+                      +zs*(2.14691708e-03+zt*(-9.27062484e-06-1.78343643e-10*zt2)+zsp5*(4.76534122e-06+1.63410736e-09*zt2)) &
+                      + zh*(5.30848875e-06+zh*zt*(-3.03175128e-16*zt2-1.27934137e-17*zh))
+                 zdenr=1.0/zden
+                 zrhotmp=znum*zdenr
+                 zdndt=7.35212840e+00+zt*(-1.091856422e-01+1.195430112e-03*zt)-7.23268813e-03*zs &
+                      +zp1t1*(2.07941058e-07-2.4773872e-11*zh)
+                 zdddt=7.28606739e-03+zt*(-9.21671084e-05+zt*(1.105171719e-06+7.23236744e-10*zt))  &
+                      +zs*(-9.27062484e-06+zt*(-5.35030929e-10*zt+3.26821472e-09*zsp5))  &
+                      +zh*zh*(-9.09525384e-16*zt2-1.27934137e-17*zh)
+                 zdnds=2.96938239e+00-7.23268813e-03*zt+2*2.12382341e-03*zs+5.18761880e-06*zh
+                 zddds=2.14691708e-03+zt*(-9.27062484e-06-1.78343643e-10*zt2)+zsp5*(7.14801183e-06+2.45116104e-09*zt2)
+                 alpha(ji,jj,jk)=(zdndt-zrhotmp*zdddt)*zdenr
+                 beta(ji,jj,jk)=zdenr*(zdnds-zrhotmp*zddds)
+
+              END DO
+           END DO
+        END DO
+
+     CASE DEFAULT
+
+        IF(lwp) WRITE(numout,cform_err)
+        IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
+        nstop = nstop + 1
+
+     END SELECT
+
+     CALL lbc_lnk( alpha, 'T', 1. )
+     CALL lbc_lnk( beta, 'T', 1. )
+
+
+     ! ---------------------------------------
+     ! 1. Horizontal tracer gradients at T-level jk
+     ! ---------------------------------------
+     DO jk = 1, jpkm1
+        DO jj = 1, jpjm1
+           DO ji = 1, fs_jpim1   ! vector opt.
+              ! i-gradient of T and S at jj
+              zdit (ji,jj,jk) = ( tb(ji+1,jj,jk)-tb(ji,jj,jk) ) * umask(ji,jj,jk)
+              zdis (ji,jj,jk) = ( sb(ji+1,jj,jk)-sb(ji,jj,jk) ) * umask(ji,jj,jk)
+              ! j-gradient of T and S at jj
+              zdjt (ji,jj,jk) = ( tb(ji,jj+1,jk)-tb(ji,jj,jk) ) * vmask(ji,jj,jk)
+              zdjs (ji,jj,jk) = ( sb(ji,jj+1,jk)-sb(ji,jj,jk) ) * vmask(ji,jj,jk)
+           END DO
+        END DO
+     END DO
+
+     IF( ln_zps ) THEN      ! partial steps correction at the last level
+# if defined key_vectopt_loop   &&   ! defined key_mpp_omp
+     jj = 1
+        DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+# else
+           DO jj = 1, jpjm1
+              DO ji = 1, jpim1
+# endif
+                 ! last ocean level
+                 iku  = MIN( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1
+                 ikv  = MIN( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1
+                 ! i-gradient of T and S
+                 zdit (ji,jj,iku) = gtu(ji,jj)
+                 zdis (ji,jj,iku) = gsu(ji,jj)
+                 ! j-gradient of T and S
+                 zdjt (ji,jj,ikv) = gtv(ji,jj)
+                 zdjs (ji,jj,ikv) = gsv(ji,jj)
+# if ! defined key_vectopt_loop   ||   defined key_mpp_omp
+              END DO
+# endif
+           END DO
+        ENDIF
+
+        ! ---------------------------------------
+        ! 1. Vertical tracer gradient at w-level jk
+        ! ---------------------------------------
+        DO jk = 2, jpk
+           zdkt(:,:,jk) = ( tb(:,:,jk-1) - tb(:,:,jk) ) * tmask(:,:,jk)
+           zdks(:,:,jk) = ( sb(:,:,jk-1) - sb(:,:,jk) ) * tmask(:,:,jk)
+        END DO
+
+        zdkt(:,:,1) = 0.0
+        zdks(:,:,1) = 0.0
+
+        ! ---------------------------------------
+        ! Depth of the w-point below ML base
+        ! ---------------------------------------
+        DO jj = 1, jpj
+           DO ji = 1, jpi
+              jk = nmln(ji,jj)
+              zr_ml_basew(ji,jj)=1.0/fsdepw(ji,jj,jk+1)
+           END DO
+        END DO
+
+
+        wslp2(:,:,:)=0.0
+        tfw(:,:,:) = 0.0
+        sfw(:,:,:) = 0.0
+        ftu(:,:,:) = 0.0
+        fsu(:,:,:) = 0.0
+        ftv(:,:,:) = 0.0
+        fsv(:,:,:) = 0.0
+        ftud(:,:,:) = 0.0
+        fsud(:,:,:) = 0.0
+        ftvd(:,:,:) = 0.0
+        fsvd(:,:,:) = 0.0
+        psix_eiv(:,:,:) = 0.0
+        psiy_eiv(:,:,:) = 0.0
+
+        ! ----------------------------------------------------------------------
+        ! x-z plane
+        ! ----------------------------------------------------------------------
+
+        ! calculate limited triad x-slopes zsx in interior (1=<jk=<jpk-1)
+        DO ip=0,1
+           DO kp=0,1
+
+              DO jk = 1, jpkm1
+                 DO jj = 1, jpjm1
+                    DO ji = 1, fs_jpim1   ! vector opt.
+
+                       ze1ur=1.0/e1u(ji,jj)
+                       zdxt=zdit(ji,jj,jk)*ze1ur
+                       zdxs=zdis(ji,jj,jk)*ze1ur
+
+                       ze3wr=1.0/fse3w(ji+ip,jj,jk+kp)
+                       zdzt=zdkt(ji+ip,jj,jk+kp)*ze3wr
+                       zdzs=zdks(ji+ip,jj,jk+kp)*ze3wr
+                       ! Calculate the horizontal and vertical density gradient
+                       zdxrho = alpha(ji+ip,jj,jk)*zdxt+beta(ji+ip,jj,jk)*zdxs
+                       zabs_dzrho = ABS(alpha(ji+ip,jj,jk)*zdzt+beta(ji+ip,jj,jk)*zdzs)+zepsln
+                       ! Limit by slpmax, and mask by psi-point
+                       zsx(ji+ip,jj,jk,1-ip,kp) = umask(ji,jj,jk+kp) &
+                            & *zdxrho/MAX(zabs_dzrho,zr_slpmax*ABS(zdxrho))
+                    END DO
+                 END DO
+              END DO
+
+           END DO
+        END DO
+
+        ! calculate slope of triad immediately below mixed-layer base
+        DO ip=0,1
+           DO kp=0,1
+              DO jj = 1, jpjm1
+                 DO ji = 1, fs_jpim1
+                    jk = nmln(ji+ip,jj)
+                    zsx_ml_base(ji+ip,jj,1-ip,kp)=zsx(ji+ip,jj,jk+1-kp,1-ip,kp)
+                 END DO
+              END DO
+           END DO
+        END DO
+
+        ! Below ML use limited zsx as is
+        ! Inside ML replace by linearly reducing zsx_ml_base towards surface
+        DO ip=0,1
+           DO kp=0,1
+
+              DO jk = 1, jpkm1
+
+                 DO jj = 1, jpjm1
+
+                    DO ji = 1, fs_jpim1   ! vector opt.
+                       ! k index of uppermost point(s) of triad is jk+kp-1
+                       ! must be .ge. nmln(ji,jj) for zfact=1.
+                       !                   otherwise  zfact=0.
+                       zfact = 1 - 1/(1 + (jk+kp-1)/nmln(ji+ip,jj))
+                       zsx(ji+ip,jj,jk,1-ip,kp) = zfact*zsx(ji+ip,jj,jk,1-ip,kp) + &
+                            & (1.0_wp-zfact)*(fsdepw(ji+ip,jj,jk+kp)*zr_ml_basew(ji+ip,jj))*zsx_ml_base(ji+ip,jj,1-ip,kp) 
+                    END DO
+
+                 END DO
+
+              END DO
+           END DO
+        END DO
+
+        ! Use zsx to calculate fluxes and save averaged slopes psix_eiv at psi-points
+        DO ip=0,1
+           DO kp=0,1
+
+              DO jk = 1, jpkm1
+
+                 DO jj = 1, jpjm1
+
+                    DO ji = 1, fs_jpim1   ! vector opt.
+
+                       ze1ur=1.0/e1u(ji,jj)
+                       zdxt=zdit(ji,jj,jk)*ze1ur
+                       zdxs=zdis(ji,jj,jk)*ze1ur
+
+                       ze3wr=1.0/fse3w(ji+ip,jj,jk+kp)
+                       zdzt=zdkt(ji+ip,jj,jk+kp)*ze3wr
+                       zdzs=zdks(ji+ip,jj,jk+kp)*ze3wr
+                       zslope=zsx(ji+ip,jj,jk,1-ip,kp)
+
+                       zvolf = 0.25_wp*e1u(ji,jj)*e2u(ji,jj)*fse3u(ji,jj,jk)
+
+                       ftu(ji,jj,jk)= ftu(ji,jj,jk)+zslope*zdzt*zvolf*ze1ur
+                       fsu(ji,jj,jk)= fsu(ji,jj,jk)+zslope*zdzs*zvolf*ze1ur
+                       ftud(ji,jj,jk)=ftud(ji,jj,jk)+fsahtu(ji,jj,jk)*zdxt*zvolf*ze1ur
+                       fsud(ji,jj,jk)=fsud(ji,jj,jk)+fsahtu(ji,jj,jk)*zdxs*zvolf*ze1ur
+                       tfw(ji+ip,jj,jk+kp)=tfw(ji+ip,jj,jk+kp)+(zvolf*ze3wr)*zslope*zdxt
+                       sfw(ji+ip,jj,jk+kp)=sfw(ji+ip,jj,jk+kp)+(zvolf*ze3wr)*zslope*zdxs
+                       wslp2(ji+ip,jj,jk+kp)=wslp2(ji+ip,jj,jk+kp)+ &
+                            & ((zvolf*ze3wr)/(e1t(ji+ip,jj)*e2t(ji+ip,jj)))*(zslope)**2
+                       psix_eiv(ji,jj,jk+kp) = psix_eiv(ji,jj,jk+kp) + 0.25_wp*zslope
+
+                    END DO
+                 END DO
+
+              END DO
+           END DO
+        END DO
+
+        ! ----------------------------------------------------------------------
+        ! y-z plane
+        ! ----------------------------------------------------------------------
+
+        ! calculate limited triad y-slopes zsy in interior (1=<jk=<jpk-1)
+        DO jp=0,1
+           DO kp=0,1
+
+              DO jk = 1, jpkm1
+                 DO jj = 1, jpjm1
+                    DO ji = 1, fs_jpim1   ! vector opt.
+
+                       ze2vr=1.0/e2v(ji,jj)
+                       zdyt=zdjt(ji,jj,jk)*ze2vr
+                       zdys=zdjs(ji,jj,jk)*ze2vr
+
+                       ze3wr=1.0/fse3w(ji,jj+jp,jk+kp)
+                       zdzt=zdkt(ji,jj+jp,jk+kp)*ze3wr
+                       zdzs=zdks(ji,jj+jp,jk+kp)*ze3wr
+                       ! Calculate the horizontal and vertical density gradient
+                       zdyrho = alpha(ji,jj+jp,jk)*zdyt+beta(ji,jj+jp,jk)*zdys
+                       zabs_dzrho = ABS(alpha(ji,jj+jp,jk)*zdzt+beta(ji,jj+jp,jk)*zdzs)+zepsln
+                       ! Limit by slpmax, and mask by psi-point
+                       zsy(ji,jj+jp,jk,1-jp,kp) = vmask(ji,jj,jk+kp) &
+                            & *zdyrho/MAX(zabs_dzrho,zr_slpmax*ABS(zdyrho))
+                    END DO
+                 END DO
+              END DO
+
+           END DO
+        END DO
+
+        ! calculate slope of triad immediately below mixed-layer base
+        DO jp=0,1
+           DO kp=0,1
+              DO jj = 1, jpjm1
+                 DO ji = 1, fs_jpim1
+                    jk = nmln(ji,jj+jp)
+                    zsy_ml_base(ji,jj+jp,1-jp,kp)=zsy(ji,jj+jp,jk+1-kp,1-jp,kp)
+                 END DO
+              END DO
+           END DO
+        END DO
+
+        ! Below ML use limited zsy as is
+        ! Inside ML replace by linearly reducing zsy_ml_base towards surface
+        DO jp=0,1
+           DO kp=0,1
+
+              DO jk = 1, jpkm1
+
+                 DO jj = 1, jpjm1
+
+                    DO ji = 1, fs_jpim1   ! vector opt.
+                       ! k index of uppermost point(s) of triad is jk+kp-1
+                       ! must be .ge. nmln(ji,jj) for zfact=1.
+                       !                   otherwise  zfact=0.
+                       zfact = 1 - 1/(1 + (jk+kp-1)/nmln(ji,jj+jp))
+                       zsy(ji,jj+jp,jk,1-jp,kp) = zfact*zsy(ji,jj+jp,jk,1-jp,kp) + &
+                            & (1.0_wp-zfact)*(fsdepw(ji,jj+jp,jk+kp)*zr_ml_basew(ji,jj+jp))*zsy_ml_base(ji,jj+jp,1-jp,kp) 
+                    END DO
+
+                 END DO
+
+              END DO
+           END DO
+        END DO
+
+        ! Use zsy to calculate fluxes and save averaged slopes psiy_eiv at psi-points
+        DO jp=0,1
+           DO kp=0,1
+
+              DO jk = 1, jpkm1
+
+                 DO jj = 1, jpjm1
+
+                    DO ji = 1, fs_jpim1   ! vector opt.
+
+                       ze2vr=1.0/e2v(ji,jj)
+                       zdyt=zdjt(ji,jj,jk)*ze2vr
+                       zdys=zdjs(ji,jj,jk)*ze2vr
+
+                       ze3wr=1.0/fse3w(ji,jj+jp,jk+kp)
+                       zdzt=zdkt(ji,jj+jp,jk+kp)*ze3wr
+                       zdzs=zdks(ji,jj+jp,jk+kp)*ze3wr
+                       zslope=zsy(ji,jj+jp,jk,1-jp,kp)
+
+                       zvolf = 0.25_wp*e1v(ji,jj)*e2v(ji,jj)*fse3v(ji,jj,jk)
+
+                       ftv(ji,jj,jk)= ftv(ji,jj,jk)+zslope*zdzt*zvolf*ze2vr
+                       fsv(ji,jj,jk)= fsv(ji,jj,jk)+zslope*zdzs*zvolf*ze2vr
+                       ftvd(ji,jj,jk)=ftvd(ji,jj,jk)+fsahtv(ji,jj,jk)*zdyt*zvolf*ze2vr
+                       fsvd(ji,jj,jk)=fsvd(ji,jj,jk)+fsahtv(ji,jj,jk)*zdys*zvolf*ze2vr
+                       tfw(ji,jj+jp,jk+kp)=tfw(ji,jj+jp,jk+kp)+(zvolf*ze3wr)*zslope*zdyt
+                       sfw(ji,jj+jp,jk+kp)=sfw(ji,jj+jp,jk+kp)+(zvolf*ze3wr)*zslope*zdys
+                       wslp2(ji,jj+jp,jk+kp)=wslp2(ji,jj+jp,jk+kp)+ &
+                            & ((zvolf*ze3wr)/(e1t(ji,jj+jp)*e2t(ji,jj+jp)))*(zslope)**2
+                       psiy_eiv(ji,jj,jk+kp) = psiy_eiv(ji,jj,jk+kp) + 0.25_wp*zslope
+
+                    END DO
+                 END DO
+
+              END DO
+           END DO
+        END DO
+
+        tfw(:,:,1)=0.0
+        sfw(:,:,1)=0.0
+        wslp2(:,:,1)=0.0
+
+        CALL lbc_lnk( wslp2, 'W', 1. )
+        CALL lbc_lnk( tfw, 'W', 1. )
+        CALL lbc_lnk( sfw, 'W', 1. )
+        CALL lbc_lnk( ftu, 'U', -1. )
+        CALL lbc_lnk( fsu, 'U', -1. )
+        CALL lbc_lnk( ftv, 'V', -1. )
+        CALL lbc_lnk( fsv, 'V', -1. )
+        CALL lbc_lnk( ftud, 'U', -1. )
+        CALL lbc_lnk( fsud, 'U', -1. )
+        CALL lbc_lnk( ftvd, 'V', -1. )
+        CALL lbc_lnk( fsvd, 'V', -1. )
+        CALL lbc_lnk( psix_eiv, 'U', -1. )
+        CALL lbc_lnk( psiy_eiv, 'V', -1. )
+
+
+      END SUBROUTINE ldf_slp_grif
 
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldftra.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 2236)
@@ -36,5 +36,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -67,5 +67,7 @@
       NAMELIST/namtra_ldf/ ln_traldf_lap  , ln_traldf_bilap,                  &
          &                 ln_traldf_level, ln_traldf_hor  , ln_traldf_iso,   &
-         &                 rn_aht_0       , rn_ahtb_0      , rn_aeiv_0
+         &                 ln_traldf_grif ,                                   &
+         &                 rn_aht_0       , rn_ahtb_0      , rn_aeiv_0,       &
+         &                 rn_slpmax
       !!----------------------------------------------------------------------
 
@@ -83,4 +85,5 @@
          WRITE(numout,*) '      laplacian operator            ln_traldf_lap   = ', ln_traldf_lap
          WRITE(numout,*) '      bilaplacian operator          ln_traldf_bilap = ', ln_traldf_bilap
+         WRITE(numout,*) '      griffies    operator          ln_traldf_grif  = ', ln_traldf_grif 
          WRITE(numout,*) '      lateral eddy diffusivity      rn_aht_0        = ', rn_aht_0
          WRITE(numout,*) '      background hor. diffusivity   rn_ahtb_0       = ', rn_ahtb_0
@@ -89,4 +92,5 @@
       ENDIF
 
+      slpmax = rn_slpmax
       !                                ! convert DOCTOR namelist names into OLD names
       aht0  = rn_aht_0
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldftra_oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 2236)
@@ -20,9 +20,12 @@
    LOGICAL , PUBLIC ::   ln_traldf_hor   = .FALSE.   !: horizontal (geopotential) direction
    LOGICAL , PUBLIC ::   ln_traldf_iso   = .TRUE.    !: iso-neutral direction
+   LOGICAL , PUBLIC ::   ln_traldf_grif  = .FALSE.   !: griffies skew flux
    REAL(wp), PUBLIC ::   rn_aht_0        = 2000._wp  !: lateral eddy diffusivity (m2/s)
    REAL(wp), PUBLIC ::   rn_ahtb_0       =    0._wp  !: lateral background eddy diffusivity (m2/s)
    REAL(wp), PUBLIC ::   rn_aeiv_0       = 2000._wp  !: eddy induced velocity coefficient (m2/s)
+   REAL(wp), PUBLIC ::   rn_slpmax       = 0.01_wp   !: slope limit
 
    REAL(wp), PUBLIC ::   aht0, ahtb0, aeiv0         !!: OLD namelist names
+   REAL(wp), PUBLIC ::   slpmax                     !: slope limit 
 
 #if defined key_traldf_c3d
@@ -41,5 +44,5 @@
    !!   'key_traldf_eiv'                              eddy induced velocity
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_traldf_eiv   = .TRUE.   !: eddy induced velocity flag
+   LOGICAL, PUBLIC, PARAMETER               ::   lk_traldf_eiv   = .TRUE.   !: eddy induced velocity flag
       
 # if defined key_traldf_c3d
@@ -67,5 +70,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!=====================================================================
 END MODULE ldftra_oce
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/OBC/obc_oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 2236)
@@ -233,5 +233,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt) 
    !!======================================================================
 END MODULE obc_oce
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/OBS/ddatetoymdhms.h90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/OBS/ddatetoymdhms.h90	(revision 2236)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/OBS/ddatetoymdhms.h90	(revision 2236)
@@ -0,0 +1,37 @@
+   SUBROUTINE ddatetoymdhms( ddate, kyea, kmon, kday, khou, kmin, ksec )
+      !!----------------------------------------------------------------------
+      !!
+      !!                    *** ROUTINE ddatetoymdhms ***
+      !!
+      !! ** Purpose : Convert YYYYMMDD.hhmmss to components
+      !!
+      !! ** Method  :
+      !!
+      !! ** Action  :
+      !!
+      !! History
+      !!----------------------------------------------------------------------
+      !! * Modules used
+
+      !! * Arguments
+      REAL(dp), INTENT(IN) :: ddate
+      INTEGER, INTENT(OUT) :: kyea
+      INTEGER, INTENT(OUT) :: kmon
+      INTEGER, INTENT(OUT) :: kday
+      INTEGER, INTENT(OUT) :: khou
+      INTEGER, INTENT(OUT) :: kmin
+      INTEGER, INTENT(OUT) :: ksec
+      !! * Local declarations
+      INTEGER :: iyymmdd
+      INTEGER :: ihhmmss
+      
+      iyymmdd = INT( ddate )
+      ihhmmss = INT( ( ddate - iyymmdd ) * 1000000 )
+      kyea = iyymmdd/10000
+      kmon = iyymmdd / 100 - 100 * kyea
+      kday = MOD( iyymmdd, 100 )
+      khou = ihhmmss/10000
+      kmin = ihhmmss / 100 - 100 * khou
+      ksec = MOD( ihhmmss, 100 )
+      
+   END SUBROUTINE ddatetoymdhms
